%Gauss elimination and back substitution
%ENRICH THIS FUNCTION BY CHECKING FOR THE DETERMINANT
%IF  DET = 0 STOP ETC. 
%Call the function as f = gaus_backsub(A,b);
function f = gaus_backsub(A,b)


n = length(A); 
m = zeros(n);

%Algorithm for reducing the coefficient matrix to upper triangular form.
%The algorithm also alters the right-hand side variables.
for j = 1:n-1
    for i = j+1:n 
        m(i,j)= A(i,j)/A(j,j);
        A(i,:) = A(i,:) - m(i,j)*A(j,:);
        b(i) = b(i) - m(i,j)*b(j);
    end
end

f1 = [A,b];

%Display the upper triangular form  
disp('Upper triangular form - row equivalent to A')  
Ag = [A,b];
disp(Ag)


%Algorithm for back substitution
for i = n:-1:1
    b(i) = b(i)/A(i,i);
    A(i,i) = A(i,i)/A(i,i);
    for j = i-1:-1:1
        b(j) = b(j) - b(i)*A(j,i)*A(i,i);
        A(j,i) = A(j,i) - A(j,i)*A(i,i);
    end 
end
f2 = [A,b];
%Display the solution to the system 
disp('Solution - Identity matrix and the right-hand side variables')  
Ag1 = [A,b];
disp(Ag1);

f = [f1;f2];
